
  

#ifndef KJSEMBED_QCanvasRectangle_H
#define KJSEMBED_QCanvasRectangle_H

#include <kjs/interpreter.h>
#include <kjs/object.h>

#include <kjsembed/jsobjectproxy_imp.h>

class QCanvasRectangle;

/**
 * Namespace containing the KJSEmbed library.
 */
namespace KJSEmbed {

/**
 * Wrapper class for QCanvasRectangle methods.
 *
 * @author Richard Moore, rich@kde.org
 */
class QCanvasRectangleImp : public JSProxyImp
{
public:
   /** Enumerates the constructors supported by this class. */
   enum Constructors {
       Constructor_QCanvasRectangle_1,
       Constructor_QCanvasRectangle_2,
       Constructor_QCanvasRectangle_3,

       LastConstuctor = -1
   };

   /** Enumerates the methods supported by this class. */
   enum Methods {

       Method_width_5,
       Method_height_6,
       Method_setSize_7,
       Method_size_8,
       Method_areaPoints_9,
       Method_rect_10,
       Method_collidesWith_11,
       Method_rtti_12,
       Method_Last = -1
   };

   QCanvasRectangleImp( KJS::ExecState *exec, int id, bool constructor=false );
   ~QCanvasRectangleImp();

   /**
    * Adds the static bindings for this class to the specified Object. The
    * static bindings are the static methods and the enums of this class.
    */
   static void addStaticBindings( KJS::ExecState *exec, KJS::Object &object );

   /**
    * Adds the bindings for this class to the specified Object. The bindings
    * added are the instance methods of this class.
    */
   static void addBindings( KJS::ExecState *exec, KJS::Object &object );

   static QCanvasRectangle *toQCanvasRectangle( KJS::Object &object );

   //
   // Constructors implemented by this class.
   //

   KJS::Object QCanvasRectangle_1( KJS::ExecState *exec, const KJS::List &args );
   KJS::Object QCanvasRectangle_2( KJS::ExecState *exec, const KJS::List &args );
   KJS::Object QCanvasRectangle_3( KJS::ExecState *exec, const KJS::List &args );

   //
   // Methods implemented by this class.
   //

   KJS::Value width_5( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args );
   KJS::Value height_6( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args );
   KJS::Value setSize_7( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args );
   KJS::Value size_8( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args );
   KJS::Value areaPoints_9( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args );
   KJS::Value rect_10( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args );
   KJS::Value collidesWith_11( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args );
   KJS::Value rtti_12( KJS::ExecState *exec, KJS::Object &obj, const KJS::List &args );

   //
   // JS binding code.
   //

   /** Returns true iff this object implements the construct function. */
   virtual bool implementsConstruct() const { return cons; }

   /** Invokes the construct function. */
   virtual KJS::Object construct( KJS::ExecState *exec, const KJS::List &args );

   /** Returns true iff this object implements the call function. */
   virtual bool implementsCall() const { return !cons; }

   /** Invokes the call function. */
   virtual KJS::Value call( KJS::ExecState *exec, KJS::Object &self, const KJS::List &args );

private:
   QCanvasRectangle *instance; // Temp
   int id;
   bool cons;
};

} // namespace KJSEmbed

#endif // KJSEMBED_QCanvasRectangle_H

// Local Variables:
// c-basic-offset: 4
// End:


